//SelectPlayerClassGui.cs

function SelectPlayerClassGui::onWake(%this)
{
}

function SelectPlayerClassGui::onSleep(%this)
{
}


function SelectPlayerClassGui::SetClass(%this, %name)
{
   //echo("setting class to " , %name);
   //SelectPlayerClass_Preview.setBitmap("base/client/ui/classPreviews/" @ %name );
   SelectPlayerClass_Preview.setBitmap("base/client/ui/classPreviews/" @ $Client::ClassImage[%name] );
   %this.currentPlayerClass = %name;
}

function ClientCmdClearClassList()
{
   %classCount = getFieldCount($Client::ClassList);

   for(%i = 0; %i < %classCount; %i++)
   {
      %name = getField($Client::ClassList, %i);
      $Client::ClassItems[%name] = "";
      $Client::ClassImage[%name] = "";
   }
   $Client::ClassList = "";
}

function ClientCmdAddClass(%text)
{
   //format: name TAB itemdb1 SPC itemdb2 SPC ... TAB preview image

   %name  = getField(%text, 0);
   %items = getField(%text, 1);
   %previewImage = getField(%text, 2);

   $Client::ClassList = trim($Client::ClassList TAB %name);
   $Client::ClassItems[%name] = %items;
   $Client::ClassImage[%name] = %previewImage;
   
   RegenerateClassList();
}  

function RegenerateClassList()
{
   SelectPlayerClass_ScrollBox.clear();

   %classCount = getFieldCount($Client::ClassList);

   for(%i = 0; %i < %classCount; %i++)
   {
      %name = getField($Client::ClassList, %i);
         
      //Selection Button
         %newButton = new GuiButtonCtrl();
         SelectPlayerClass_ScrollBox.add(%newButton);

         //position and resize
         %newButton.horizSizing = "right";
         %buttonX = 0;
         %buttonY = ((30 + 64 + 4) * %i); 
         %buttonW = 162;
         %buttonH = 25;
         %newButton.resize(%buttonX, %buttonY, %buttonW, %buttonH);

         %newButton.setText(%name);
         %newButton.command = "SelectPlayerClassGui.SetClass(" @ %name @ ");";
      
      //Inventory weapon icons
         %weaponCount = 0;
         %itemCount = getWordCount($Client::ClassItems[%name]);
         for(%j = 0; %j < %itemCount; %j++)
         {
            %item = getWord($Client::ClassItems[%name], %j);
            if(%item.category !$= "Weapon")
               continue;

            %newIcon = new GuiBitmapCtrl();
            SelectPlayerClass_ScrollBox.add(%newIcon);
            %newIcon.setBitmap("base/client/ui/weaponIcons/" @ %item.iconName);
            
            %x = %weaponCount * 66 + 10;
            %y = %buttonY + %buttonH + 2;
            %w = 64;
            %h = 64;
            %newIcon.resize(%x,%y,%w, %h);

            %weaponCount++;
         }
      
      //Inventory Item Icons
         %miscItemCount = 0;
         %itemCount = getWordCount($Client::ClassItems[%name]);
         for(%j = 0; %j < %itemCount; %j++)
         {
            %item = getWord($Client::ClassItems[%name], %j);
            if(%item.category $= "Weapon")
               continue;
            if(%item.category $= "Ammo")
               continue;

            %newIcon = new GuiBitmapCtrl();
            SelectPlayerClass_ScrollBox.add(%newIcon);
            %newIcon.setBitmap("base/client/ui/weaponIcons/" @ %item.iconName);
            
            %x = (%weaponCount * 66 + 10) + %miscItemCount * 34;
            %y = %buttonY + %buttonH + 2 + 32;
            %w = 32;
            %h = 32;
            %newIcon.resize(%x,%y,%w, %h);

            %miscItemCount++;
         }
   }

   //resize window
   %x = getWord(SelectPlayerClass_ScrollBox.getPosition(), 0);
   %y = getWord(SelectPlayerClass_ScrollBox.getPosition(), 1);
   %w = getWord(SelectPlayerClass_ScrollBox.getExtent(), 0);
   %h = ((%classCount) * (30 + 64 + 4));
   SelectPlayerClass_ScrollBox.resize(%x,%y,%w,%h);
}

function SelectPlayerClassGui::ChangeNow(%this)
{
   if(%this.currentPlayerClass $= "")
      return;
   commandToServer('SetSpawnClass', %this.currentPlayerClass);
   %teamID = SelectPlayerClass_TeamList.getSelected();

   switch(%teamID)
   {
      case -1: //auto join
         commandToServer('AutoJoinTeam');
      default:
         commandToServer('JoinTeam', %teamID);
   }
   
   canvas.popDialog(%this);
}

function SelectPlayerClassGui::ChangeAtRespawn(%this)
{
   if(%this.currentPlayerClass $= "")
      return;
   commandToServer('SetSpawnClass', %this.currentPlayerClass);
   %teamID = SelectPlayerClass_TeamList.getSelected();
   commandToServer('SetSpawnTeam', %teamID);
   
   canvas.popDialog(%this);
}