//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Hook into the client update messages to maintain our player list
// and scoreboard.
//-----------------------------------------------------------------------------

addMessageCallback('MsgClientJoin', handleClientJoin);
addMessageCallback('MsgClientDrop', handleClientDrop);
addMessageCallback('MsgClientScoreChanged', handleClientScoreChanged);

//-----------------------------------------------------------------------------

function handleClientJoin(%msgType, %msgString, %clientName, %clientId, %team, %adminLevel )
{
   %clientName = StripMLControlChars(deTag(%clientName));

   //PlayerListGui.update(%clientId,%clientName,%isSuperAdmin,
   //   %isAdmin,%isAI,%score);

   PlayerList.setRowByID(%clientID, %clientName TAB %team TAB %adminLevel);
   ScoreGui.regenerate();
}

function handleClientDrop(%msgType, %msgString, %clientName, %clientId)
{
   //PlayerListGui.remove(%clientId);
   PlayerList.removeRowByID(%clientID);
   ScoreGui.regenerate();
}

function handleClientScoreChanged(%msgType, %msgString, %score, %clientId)
{
   //PlayerListGui.updateScore(%clientId,%score);
}
