//whosTalking.cs
//manages the "who's talking" list thats above the chat


function WhoTalk_Init()
{
	if(isObject($WhoTalkSO))
		$WhoTalkSO.delete();

	$WhoTalkSO = new ScriptObject()
	{
		class = WhoTalkSO;
		textObj = chatWhosTalkingText.getID();
		count = 0;
	};
}

function WhoTalk_Kill()
{
	if(isObject($WhoTalkSO))
	{
		$WhoTalkSO.textObj.setText("");
		$WhoTalkSO.delete();
	}
}

function WhoTalk_AddId(%client)
{
	if(!isObject($WhoTalkSO))
		WhoTalk_init();

	$WhoTalkSO.addID(%client);
}

function WhoTalk_RemoveId(%client)
{
	if(!isObject($WhoTalkSO))
		return;
	
	$WhoTalkSO.removeID(%client);
}


function WhoTalkSO::AddId(%this, %client)
{
	if(%this.HasID(%client)) //dont add the same guy more than once
		return;
	
	%this.id[%this.count] = %client;
	%this.count++;

	%this.display();
}

function WhoTalkSO::RemoveId(%this, %client)
{
	for(%i = 0; %i < %this.count; %i++)
	{
		if(%this.id[%i] == %client)
		{
			//found it, remove and shuffle down
			for(%j = %i + 1; %j < %this.count; %j++)
			{
				%this.id[%j - 1] = %this.id[%j];
			}
			%this.count--;
			%this.display();
			return;
		}
	}
}

function WhoTalkSO::HasId(%this, %client)
{
	for(%i = 0; %i < %this.count; %i++)
	{
		if(%this.id[%i] == %client)
			return true;
	}	
	return false;
}

function WhoTalkSO::Display(%this)
{
	%text = %this.textObj;

	if(isObject(%text))
	{
		%buff = "";
		for(%i = 0; %i < %this.count; %i++)
		{
         %playerName = getField(PlayerList.getRowTextByID(%this.id[%i]), 0);
         %colorCode = getField(PlayerList.getRowTextByID(%this.id[%i]), 1);
         switch(%colorCode)
         {
            case 0:
               %colorCode = "\c0";
            case 1:
               %colorCode = "\c1";
            case 999:
               %colorCode = "\c6";
            default:
               %colorCode = "\c7";
         }
			%buff = %buff @ " " @ %colorCode @ %playerName;
		}
		%text.setText(%buff);
	}
	else
	{
		error("ERROR: WhoTalkSO::Display() - text object not found.");
	}
}





//who's talking box
addMessageCallback('MsgStartTalking', handleStartTalking);

function handleStartTalking(%msgType, %msgString, %clientID)
{
	WhoTalk_addID(%clientID);
}

addMessageCallback('MsgStopTalking', handleStopTalking);

function handleStopTalking(%msgType, %msgString, %clientID)
{
	WhoTalk_removeID(%clientID);
}