//*****************************************************************************
// Custom Materials
//*****************************************************************************

// for writing to z buffer
new CustomMaterial( Blank )
{
   shader = BlankShader;
   version = 1.1;
};


//*****************************************************************************
// Environmental Materials
//*****************************************************************************

new CustomMaterial(AtlasDynamicLightingMaskMaterial)
{
   texture[0] = "$dynamiclight";
   texture[1] = "$dynamiclightmask";
   shader = AtlasDynamicLightingMaskShader;
   version = 1.1;
   preload = true;
};

new CustomMaterial(AtlasDynamicLightingMaterial)
{
   texture[0] = "$dynamiclight";
   shader = AtlasDynamicLightingShader;
   version = 1.1;
   preload = true;
};

new CustomMaterial(AtlasMaterial)
{
   shader = AtlasShader;
   version = 1.1;

   dynamicLightingMaterial = AtlasDynamicLightingMaterial;
   dynamicLightingMaskMaterial = AtlasDynamicLightingMaskMaterial;
   preload = true;
};

new CustomMaterial(AtlasBlender20Material)
{
   shader = AtlasBlender20Shader;
   version = 2.0;
   preload = true;
};

new CustomMaterial(TerrainMaterialDynamicLightingMask)
{
   texture[2] = "$dynamiclight";
   texture[3] = "$dynamiclightmask";
   
   shader = TerrDynamicLightingMaskShader;
   version = 1.1;
   preload = true;
};

new CustomMaterial(TerrainMaterialDynamicLighting)
{
   texture[2] = "$dynamiclight";

   shader = TerrDynamicLightingShader;
   version = 1.1;
   preload = true;
};

new CustomMaterial(TerrainMaterial)
{
   shader = TerrShader;
   version = 1.1;

   texture[3] = "~/data/textures/terrain/detail/detail01";
   
   dynamicLightingMaterial = TerrainMaterialDynamicLighting;
   dynamicLightingMaskMaterial = TerrainMaterialDynamicLightingMask;
   preload = true;
};

new CustomMaterial(TerrainBlenderPS20Material)
{
   shader = TerrBlender20Shader;
   version = 2.0;
   preload = true;
};

new CustomMaterial(TerrainBlenderPS11AMaterial)
{
   shader = TerrBlender11AShader;
   pixVersion = 1.1;
   preload = true;
};

new CustomMaterial(TerrainBlenderPS11BMaterial)
{
   shader = TerrBlender11BShader;
   pixVersion = 1.1;
   preload = true;
};



