//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Misc. server commands avialable to clients
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

function serverCmdSAD( %client, %password )
{
   if( %password !$= "" && %password $= $Pref::Server::AdminPassword)
   {
      %client.isAdmin = true;
      %client.isSuperAdmin = true;
      %name = getTaggedString( %client.name );
      MessageAll( 'MsgAdminForce', "\c2" @ %name @ " has become Admin by force.", %client );   
   }
}

function serverCmdSADSetPassword(%client, %password)
{
   if(%client.isSuperAdmin)
      $Pref::Server::AdminPassword = %password;
}


//----------------------------------------------------------------------------
// Server chat message handlers

function serverCmdTeamMessageSent(%client, %text)
{
   if(strlen(%text) >= $Pref::Server::MaxChatLen)
      %text = getSubStr(%text, 0, $Pref::Server::MaxChatLen);
   
   %name = stripMLControlChars(getTaggedString(%client.name));
   %color = TeamManager_SO.getTeamHexColor(%client.team);

   chatMessageTeam(%client, %client.team, "\c6(T)" @ %color @ %name @ " \c7:\c6 " @ %text);
}

function serverCmdMessageSent(%client, %text)
{
   if(strlen(%text) >= $Pref::Server::MaxChatLen)
      %text = getSubStr(%text, 0, $Pref::Server::MaxChatLen);

   %name = stripMLControlChars(getTaggedString(%client.name));
   %color = TeamManager_SO.getTeamHexColor(%client.team);

   chatMessageAll(%client, %color @ %name @ " \c7:\c3 " @ %text);
}


function serverCmdTeamMessageSent(%client, %text)
{
	%obj = %client.player;

	if(isObject(%obj))
	{
		%obj.playthread(3, talk);			
		%obj.schedule(strlen(%text) * 50 , playThread, 3, root);
	}

	//remove control characters (no images, links, or font changes please)
	%text = StripMLControlChars(%text);

	//remove excess spaces
	%text = trim(%text);
	
	if($Pref::Server::MaxChatLen > 0)
		if(strlen(%text) >= $Pref::Server::MaxChatLen)
			%text = getSubStr(%text, 3, $Pref::Server::MaxChatLen);

	//detect urls and insert anchor tags
	%protocolLen = 7;
	%urlStart = strPos(%text, "http://");
	if(%urlStart == -1)
	{
		%protocolLen = 8;
		%urlStart = strPos(%text, "https://");
	}
	if(%urlStart == -1)
	{
		%protocolLen = 6;
		%urlStart = strPos(%text, "ftp://");
	}

	if(%urlStart != -1)
	{
		//find the end of the url
		%urlEnd = strPos(%text, " ", %urlStart + 1);
		if(%urlEnd == -1)
		{
			%fullUrl = getSubStr(%text, %urlStart, strLen(%text) - %urlStart);
			%url = getSubStr(%text, %urlStart + %protocolLen, strLen(%text) - %urlStart - %protocolLen);
		}
		else
		{
			%fullUrl = getSubStr(%text, %urlStart, %urlEnd - %urlStart);
			%url = getSubStr(%text, %urlStart + %protocolLen, %urlEnd - %urlStart - %protocolLen);
		}
		%text = strReplace(%text, %fullUrl, "<a:"@%url@">"@%url@"</a>\c4");
	}
	//done inserting url codes

//	//curseword filter
//		if($Pref::Server::CurseFilter)
//		{
//			if(!chatFilter(%client, %text, $Pref::Server::CurseList, '\c5Do not use foul language.'))
//				return 0;
//		}
//
//	//retard-o-speech filter
//		if($Pref::Server::ETardFilter)
//		{	
//			if(!chatFilter(%client, %text, $Pref::Server::ETardList, '\c5This is a civilized game.  Please use full words.'))
//				return 0;
//		}
	

	if(strLen(%text) <= 0)
		return;

	
	//chatMessageTeam(%client, %client.team, '\c3%1: \c4%2', %client.name, %text);
	//chatMessageTeam(%client, %client.team, '\c7%1\c3%2\c7%3\c4: %4', %client.clanPrefix, %client.name, %client.clanSuffix, %text);

   %name = %client.getColoredName();
   chatMessageTeam(%client, %client.team, "\c6(T)" @ %color @ %name @ " \c7:\c6 " @ %text);
	echo("(T)", %client.name, ": ", %text);
}

function serverCmdMessageSent(%client, %text)
{
	%obj = %client.player;

	if(isObject(%obj))
	{
		%obj.playthread(3, talk);				
		%obj.schedule(strlen(%text) * 50, playThread, 3, root);
	}

	//remove control characters (no images, links, or font changes please)
	%text = StripMLControlChars(%text);

	//remove bad things
	%text = strReplace(%text, "<a:", "");
	
	//remove excess spaces
	%text = trim(%text);

	//cap at maxlen
	if($Pref::Server::MaxChatLen > 0)
		if(strlen(%text) >= $Pref::Server::MaxChatLen)
			%text = getSubStr(%text, 0, $Pref::Server::MaxChatLen);
	
	//detect urls and insert anchor tags
	%protocolLen = 7;
	%urlStart = strPos(%text, "http://");
	if(%urlStart == -1)
	{
		%protocolLen = 8;
		%urlStart = strPos(%text, "https://");
	}
	if(%urlStart == -1)
	{
		%protocolLen = 6;
		%urlStart = strPos(%text, "ftp://");
	}

	if(%urlStart != -1)
	{
		echo("URL FOUND");
		//find the end of the url
		%urlEnd = strPos(%text, " ", %urlStart + 1);
		if(%urlEnd == -1)
		{
			%fullUrl = getSubStr(%text, %urlStart, strLen(%text) - %urlStart);
			%url = getSubStr(%text, %urlStart + %protocolLen, strLen(%text) - %urlStart - %protocolLen);
		}
		else
		{
			%fullUrl = getSubStr(%text, %urlStart, %urlEnd - %urlStart);
			%url = getSubStr(%text, %urlStart + %protocolLen, %urlEnd - %urlStart - %protocolLen);
		}

		%newText = strReplace(%text, %fullUrl, "<a:"@%url@">"@%url@"</a>\c6");

		%text = %newText;
	}
	//done inserting url codes


//	//curseword filter
//		if($Pref::Server::CurseFilter)
//		{
//			if(!chatFilter(%client, %text, $Pref::Server::CurseList, '\c5Do not use foul language.'))
//				return 0;
//		}
//
//	//retard-o-speech filter
//		if($Pref::Server::ETardFilter)
//		{	
//			if(!chatFilter(%client, %text, $Pref::Server::ETardList, '\c5This is a civilized game.  Please use full words.'))
//				return 0;
//		}

	if(strLen(%text) <= 0)
	{
		error("ERROR: null chat");
		return;
	}

	 //chatMessageAll(%client, "\c3"@StripMLControlChars(getTaggedString(%client.name))@": \c6"@%text);
   //chatMessageAll(%client, '\c3%1: \c6%2', %client.name, %text);
   //chatMessageAll(%client, '\c7%1\c3%2\c7%3\c6: %4', %client.clanPrefix, %client.name, %client.clanSuffix, %text);
   %name = %client.getColoredName();
   chatMessageAll(%client, %name @ " \c7:\c3 " @ %text);
   echo(%name, ": ", %text);
}
