datablock DebrisData( GrenadeLauncherDebris )
{

   explodeOnMaxBounce = false;

   elasticity = 0.5;   friction = 0.5;

   lifetime = 0.6;   lifetimeVariance = 0.1;

   minSpinSpeed = 50;   maxSpinSpeed = 100;

   numBounces = 2;   bounceVariance = 0;

   staticOnMaxBounce     = false; //
   snapOnMaxBounce       = false; // stick to the ground on max bounce
   fade                  = true;

   //velocity = 1.0;   velocityVariance = 0;  // overrides DebrisVelocity from parent explosion

   //other values
   emitters = "GrenadeDebrisTrailEmitter"; // particle trail
   //texture = ""; //
   //explosion = "GrenadeDebrisExplosion"; // explosion datablock used if explodeOnMaxBounce = true
   //render2D = false; // default false
   shapeFile = "~/data/shapes/explosions/debris_01.dts"; // mesh of debris
   useRadiusMass = true; // for weight, default false
   baseRadius = 1.0; // fake size for weight, default 1
   gravModifier = 4.0; // adjust gravity for weight, default 1
   //terminalVelocity = 0; // maximum speed, default 0
   ignoreWater = true; // bounce or explode on water, default false
};


datablock ShockwaveData( GrenadeLauncherShockwave )
{
   width = 11.0;
   numSegments = 12;
   numVertSegments = 2;
   velocity = 8;
   acceleration = 1.0;
   lifetimeMS = 700;
   height = 1.5;
   verticalCurve = 5;
   is2D = false;

   renderSquare = false;
	orientToNormal = false;
	renderBottom = false;

   texture[0] = "~/data/shapes/explosions/shockwavemortar.png";
   texture[1] = "~/data/shapes/explosions/shockwave3.png";
   texWrap = 10.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.9 0.7 0.0 0.9";
   colors[1] = "0.8 0.6 0.0 0.4";
   colors[2] = "0.5 0.5 0.5 0.0";
};

datablock ExplosionData( GrenadeLauncherExplosion )
{
    //explosionShape = "~/data/shapes/wep_glauncher/explosion/glauncher_exp.dts";
    soundProfile = "GrenadeLauncherExplosionSound";
    faceViewer = false; // lock rotation to face player at all times
    offset = 1; // closer toward viewer

   particleEmitter = GrenadeLauncherExplosionEmitter;
   particleDensity = 200;
   particleRadius = 1.0; // an area, not like offset, more like multiple points

    //explosionScale = "3 3 3";  // englarges the explosionShape visually, default "1 1 1"
    //playSpeed = 1.3; // speed the explosionShape DTS will animate, default 1

    shockwave = "GrenadeLauncherShockwave"; // datablock of effect for ring type shockwave
    shockwaveOnTerrain = true;
    shockwaveOnInterior = true;

    debris = "GrenadeLauncherDebris";
    debrisThetaMin = 0;
    debrisThetaMax = 90;
    debrisPhiMin = 0;
    debrisPhiMax = 360;
    debrisNum = 6;
    debrisNumVariance = 2;
    debrisVelocity = 35;
    debrisVelocityVariance = 20;

    delayMS = 0;
    delayVariance = "0";

    lifetimeMS = 1992;
    lifetimeVariance = 200;

    times[0] = 0;
    times[1] = 0.4;
    times[2] = 0.8;
    times[3] = 1.2;
    //times[4] = 0.8;
    //times[5] = 1.0;

    sizes[0] = "2.5 2.5 2.5";
    sizes[1] = "2.5 2.5 2.5";
    sizes[2] = "2.2 2.2 2.2";
    sizes[3] = "2 2 2";
    //sizes[4] = "3 3 3";
    //sizes[5] = "2 2 2";

    shakeCamera = true;
    camShakeFreq = "5 2 7";
    camShakeAmp = "10 8 14";
    camShakeDuration = 2.0;
    camShakeRadius = 40;
    camShakeFalloff = 20;

    lightStartRadius = 9;
    lightEndRadius = 10;
    lightStartColor = "1 0.4 0.1 1";
    lightEndColor = "0 0 0 1";
    lightHasCorona = true;
};
