//PlayerClass.cs



function ServerCmdSetSpawnClass(%client, %playerClass)
{
   %client.playerClass = %playerClass;
   //%client.spawnPlayer();  //probably a bad idea
}

function GameConnection::GetPlayerClassDataBlock(%client)
{
   switch$(%client.playerClass)
   {
      case "Sniper":
         %dbName = "LightMaleArmor";            
      case "Light":
         %dbName = "LightMaleArmor";
      case "Heavy":
         %dbName = "HeavyMaleArmor";
      default:
         %dbName = "LightMaleArmor";
   }
   
   switch(%client.team)
   {
      case 0:
         %dbName = "Red_" @ %dbName;
      case 1:
         %dbName = "Blue_" @ %dbName;
      default:
         error("ERROR: GameConnection::GetPlayerDataBlock() - unknown team: " @ %client.team);
         %dbName = "Red_" @ %dbName;
   }
   
   return %dbName;
}

$Server::ClassCount = -1;

$class = "Soldier";
$Server::Class[$Server::ClassCount++] = $class;
$Server::ClassPreviewImage[$class] = "Soldier";
$i = -1;
$SpawnEquipment::Item[$class, $i++]   = DiscLauncher        TAB 1;
$SpawnEquipment::Item[$class, $i++]   = DiscLauncherAmmo    TAB 15;
$SpawnEquipment::Item[$class, $i++]   = FlameThrower        TAB 1;
$SpawnEquipment::Item[$class, $i++]   = FlameThrowerAmmo    TAB 250;
$SpawnEquipment::Item[$class, $i++]   = HandGrenade         TAB 10;
$SpawnEquipment::Item[$class, $i++]   = HealthKit           TAB 1;
$SpawnEquipment::ItemCount[$class] = $i;

$class = "Sniper";
$Server::Class[$Server::ClassCount++] = $class;
$Server::ClassPreviewImage[$class] = "Sniper";
$i = -1;
$SpawnEquipment::Item[$class, $i++]   = LaserRifle    TAB 1;
$SpawnEquipment::Item[$class, $i++]   = Shotgun       TAB 1;
$SpawnEquipment::Item[$class, $i++]   = ShotgunAmmo   TAB 20;
$SpawnEquipment::Item[$class, $i++]   = HealthKit     TAB 1;
$SpawnEquipment::ItemCount[$class] = $i;

$class = "Engineer";
$Server::Class[$Server::ClassCount++] = $class;
$Server::ClassPreviewImage[$class] = "Engineer";
$i = -1;
$SpawnEquipment::Item[$class, $i++]   = DiscLauncher        TAB 1;
$SpawnEquipment::Item[$class, $i++]   = DiscLauncherAmmo    TAB 15;
$SpawnEquipment::Item[$class, $i++]   = TurretGun           TAB 1;
$SpawnEquipment::Item[$class, $i++]   = TurretGunAmmo       TAB 100;
$SpawnEquipment::Item[$class, $i++]   = HealthStationGun    TAB 1;
$SpawnEquipment::Item[$class, $i++]   = HealthStationGunAmmo       TAB 100;
$SpawnEquipment::Item[$class, $i++]   = SatchelCharge       TAB 10;
$SpawnEquipment::Item[$class, $i++]   = HealthKit           TAB 1;
$SpawnEquipment::ItemCount[$class] = $i;

$class = "Juggernaut";
$Server::Class[$Server::ClassCount++] = $class;
$Server::ClassPreviewImage[$class] = "Juggernaut";
$i = -1;
$SpawnEquipment::Item[$class, $i++]   = DiscLauncher        TAB 1;
$SpawnEquipment::Item[$class, $i++]   = DiscLauncherAmmo    TAB 30;
$SpawnEquipment::Item[$class, $i++]   = ChainGun            TAB 1;
$SpawnEquipment::Item[$class, $i++]   = ChainGunAmmo        TAB 500;
$SpawnEquipment::Item[$class, $i++]   = GrenadeLauncher     TAB 1;
$SpawnEquipment::Item[$class, $i++]   = GrenadeLauncherAmmo TAB 30;
$SpawnEquipment::Item[$class, $i++]   = Mortar              TAB 1;
$SpawnEquipment::Item[$class, $i++]   = MortarAmmo          TAB 30;
$SpawnEquipment::Item[$class, $i++]   = HealthKit           TAB 1;
$SpawnEquipment::ItemCount[$class] = $i;

//after a player is created, call this to give them their starting equipment
function GameConnection::GiveSpawnEquipment(%client)
{
   %player = %client.player;
   %class = %client.playerClass;
   
   for(%i = 0; %i <= $SpawnEquipment::Itemcount[%class]; %i++)
   {
      %item = getWord($SpawnEquipment::Item[%class, %i], 0);
      %amt  = getWord($SpawnEquipment::Item[%class, %i], 1);
      %player.incInventory(%item, %amt, 1); //1 = do not transmit
   }
}

function GameConnection::SendClassList(%client)
{  
//   %list = "";
//   for(%i = 0; %i <= $Server::ClassCount; %i++)
//   {
//      %list = %list TAB $Server::Class[%i];
//   }
//   %list = trim(%list);
//
//   commandToClient(%client, 'SetClassList', %list);
   
   commandToClient(%client, 'ClearClassList');

   for(%i = 0; %i <= $Server::ClassCount; %i++)
   {
      %name = $Server::Class[%i];
      
      %itemList = "";
      for(%j = 0; %j <= $SpawnEquipment::Itemcount[%name]; %j++)
      {
         %item = getWord($SpawnEquipment::Item[%name, %j], 0);
         if(%item.category !$= "Ammo")
         {
            %itemList = %itemList SPC %item.getid();
         }
      }
      %itemList = trim(%itemList);
      
      %previewImage = $Server::ClassPreviewImage[%name];

      //format: name TAB itemdb1 SPC itemdb2 SPC ... TAB preview image
      %line = %name TAB %itemList TAB %previewImage;
      commandToclient(%client, 'AddClass', %line);
   }
}