//projectile.cs


//there is no concept of fade in the projectile code
function ProjectileData::onCollision( %data, %projectile, %targetObject, %position, %normal, %velocity )
{
   if( !(%targetObject.getType() & $TypeMasks::ShapeBaseObjectType) )
      return;

   if(!TeamManager_SO.canDamage(%projectile,%targetObject))
      return;

   if(%targetObject.getType() & $TypeMasks::PlayerObjectType)
      %projectile.client.incStat("RoundsDirectHit_" @ %data.getName());

   %data.damage(%projectile,%targetObject,%position,%normal, %velocity);
   %data.impactImpulse(%projectile,%targetObject,%velocity);

   //echo("  position    = ", %position);
   //echo("  normal      = ", %normal);
   //echo("  Velocity    = ", %velocity);
}


function ProjectileData::onExplode(%this,%obj, %pos)
{
	//echo("PROJECTILE EXPLODED! ", %this, "|", %obj, "|", %pos);

	//can't damage if we have no shooter
		%client = %obj.client;
      //echo("  client = ", %client);
		if(!isObject(%client) && %client !$= "")
      {
         echo("ProjectileData::onExplode() - no client, bailing.  client = ", %client);
         return;
      }
     
   //dont search if no radius (or no effect)
		if ((%this.damageRadius <= 0 || %this.radiusDamage <= 0) &&
		   ((%this.impulse && %this.impulseVertical) <= 0 || %this.impulseRadius <=0))
		{
         //echo("ProjectileData::onExplode() - no damage or impulse to apply");
			return;
		}
	//echo("searching... ", %this.damageRadius);
	
	//do a damage radius check for people in this minigame
		if(%this.damageRadius > %this.impulseRadius)
			%radius = %this.damageRadius;
		else
			%radius = %this.impulseRadius;

         //echo("  radius = ", %radius);

		%mask = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::CorpseObjectType | $TypeMasks::ItemObjectType | $TypeMasks::StaticShapeObjectType;
      %coverageMask = $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::StaticObjectType;
		initContainerRadiusSearch(%pos, %radius, %mask);
		while ((%searchObj = containerSearchNext()) != 0)
		{
			//echo("  obj = ", %searchobj);
			%searchObj = getWord(%searchObj,0);	//forget the extra position data and stuff

         if(!TeamManager_SO.canDamage(%obj,%searchObj))
            continue;

//			if(%searchObj.getType() & $TypeMasks::PlayerObjectType)
//			{
//				//compensate for culling hack
//            %searchPos = %searchObj.getHackPosition();
//			}
//			else
//			{
				%searchPos = %searchObj.getWorldBoxCenter();
//			}

         if(%searchObj.getType() & $TypeMasks::PlayerObjectType)
            if(isObject(%obj.client) && %searchObj != %obj.client.player)
               %obj.client.incStat("RoundsRadiusHit_" @ %this.getName());

			%dist = vectorDist(%searchPos, %pos);
			%damageDistFactor = 1 -  ((%dist / %this.damageRadius ) * (%dist / %this.damageRadius ));		
			%impulseDistFactor = 1 - ((%dist / %this.impulseRadius) * (%dist / %this.impulseRadius));		

         %coverage = calcExplosionCoverage(%pos, %searchObj, %coverageMask);
         %damageDistFactor *= %coverage;
         %impulseDistFactor *= %coverage;

         //new style damage check - attacking client vs target object
         //if(miniGameCanDamage(%client, %searchObj) == true)
         //{
            %this.radiusDamage(%obj, %searchObj, %damageDistFactor, %pos, %this.radiusDamage);
            %this.radiusImpulse(%obj, %searchObj, %impulseDistFactor, %pos, %this.impulseForce, %this.impulseVertical);
         //}
			
		}	//end while

} //end function


function ProjectileData::damage(%this,%obj,%col,%pos,%normal, %velocity)
{
   //echo("ondamage");
   if(%this.directDamage <= 0)
      return;

   //do headshots/torso/leg shots?
   if(%this.doLocationDamage)
   {
      %boxZmin = getWord(%col.getWorldBox(), 2);
      %boxZmax = getWord(%col.getWorldBox(), 5);
      
      %boxHeight = %boxZmax - %boxZmin;

      %posZ = getWord(%pos, 2);
      %posZheight = %posZ - %boxZmin;

      %ratio = %posZHeight / %boxHeight;

      if(%ratio > 0.82)
         %damageAmt = %this.directDamageHead;
      else if(%ratio > 0.47)
         %damageAmt = %this.directDamageTorso;
      else
         %damageAmt = %this.directDamageLegs;
   }
   else
   {
      %damageAmt = %this.directDamage;
   }

   //scale damage amount based on percentage of muzzle velocity
   if(%this.scaleDirectDamageBySpeed)
   {
      %speed = vectorLen(%velocity);
      %damageAmt *= (%speed / %this.muzzleVelocity);
   }

   //projectile can set it's own damage percentage - mainly for the laser rifle
   if(%obj.damageLevel !$= "")
      %damageAmt *= %obj.damageLevel;

   //echo("damaging ", %damageAmt);

	//direct damage doubles for crouching players
   //%damageType = $DamageType::Direct;
   //if(%this.DirectDamageType)
   //   %damageType = %this.DirectDamageType;

   //echo("projectiledata::damage " @ %this @"|"@ %obj @"|"@ %col @"|"@ %pos  @"|"@  %normal);

   %col.damage(%obj, %pos, %damageAmt, %damageType);
}

function ProjectileData::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt)
{
   //validate distance factor
   if(%distanceFactor <= 0)
      return;
   else if(%distanceFactor > 1)
      %distanceFactor = 1;

      //echo("radius damaging ", %col);

   %damageAmt *= %distanceFactor;

   if(%damageAmt)
   {
      //use default damage type if no damage type is given
      //%damageType = $DamageType::Radius;
      //if(%this.RadiusDamageType)
      //   %damageType = %this.RadiusDamageType;

      %col.damage(%obj, %pos, %damageAmt, %damageType);
   }
}

function ProjectileData::radiusImpulse(%this, %obj, %col, %distanceFactor, %pos, %impulseAmt, %verticalAmt)
{
	//validate distance factor
		if(%distanceFactor <= 0)
			return;
		else if(%distanceFactor > 1)
			%distanceFactor = 1;


        // echo("radius impusling ", %col);

	if(%impulseAmt || %verticalAmt)
	{
		%colPos = %col.getPosition();
		%colPos = vectorAdd(%colPos, "0 0 1");

		%impulseVec = VectorSub(%colPos, %pos);
      //regular impulse
		%impulseVec = VectorNormalize(%impulseVec);
		%impulseVec = VectorScale(%impulseVec, %impulseAmt * %distanceFactor);
      %col.applyImpulse(%pos, %impulseVec);

      //echo("applying impulse ");
      //echo("  pos = ", %pos);
      //echo("  vec = ", %impulseVec);
         

      //this code is from blockland to make you shoot up out of exploding jeeps
      if(%obj.upVector !$= "")
         %impulseVec = VectorScale(%obj.upVector, %verticalAmt * %distanceFactor);
      else
         %impulseVec = VectorScale("0 0 1", %verticalAmt * %distanceFactor);
      %col.applyImpulse(%pos, %impulseVec);
      
      //record last pusher so we can give credit for throwing people into walls
      if(isObject(%obj.client))
      {
         %col.lastPusher = %obj.client;
         %col.lastPushTime = getSimTime();
      }
	}
}

function ProjectileData::ImpactImpulse(%this, %obj, %col, %vector)
{
	%vector = vectorNormalize(%vector);
	%colPos = %col.getPosition();

   %col.preHitVelocity = %col.getVelocity();
   
//      echo("impact impulse ", %vector);

	//apply impact impulse
		%col.applyImpulse(%colPos, vectorScale(%vector, %this.impactImpulse));
	//apply vertical impulse
		%col.applyImpulse(%colPos, "0 0" SPC %this.impactImpulseVertical);	

   //record last pusher so we can give credit for throwing people into walls
   if(isObject(%obj.client))
   {
      %col.lastPusher = %obj.client;
      %col.lastPushTime = getSimTime();
   }
}

