//serverCmd.cs


//use a specific item
function serverCmdUse( %client, %data )
{
   if(!isObject(%data))
      return;

   %player = %client.player;
   if(!isObject(%player))
      return;

   if(%player.getDamageState() !$= "Enabled")
      return;

   if(%player.getInventory(%data) > 0)
      %player.use(%data);
}


//drop a specific item
function serverCmdThrow( %client, %data )
{
   if(!isObject(%data))
      return;

   %player = %client.player;
   if(!isObject(%player))
      return;

   %player.throw(%data);
}

//drop the weapon you are currently holding
function serverCmdDropWeapon(%client)
{
   %player = %client.player;
   if(!isObject(%player))
      return;
  
   %image = %player.getMountedImage(0);
   if(!isObject(%image))
      return;
   
   %item = %image.item;
   if(!isObject(%item))
      return;

   %player.throw(%item);
}

//drop ammo from the weapon you are currently holding
function serverCmdDropAmmo(%client)
{
   %player = %client.player;
   if(!isObject(%player))
      return;
   
   %image = %player.getMountedImage(0);
   if(!isObject(%image))
      return;

   %ammo = %image.ammo;
   if(!isObject(%ammo))
      return;
   
   %player.throw(%ammo);      
}




function serverCmdStartTalking(%client)
{
	if(%client.isTalking)
		return;
	
	%client.isTalking = true;
	
	//tell the other clients who is talking
	for( %clientIndex = 0; %clientIndex < ClientGroup.getCount(); %clientIndex++ )
	{
		%cl = ClientGroup.getObject( %clientIndex );
		messageClient(%cl, 'MsgStartTalking', '', %client);
	}
}

function serverCmdStopTalking(%client)
{
	if(!%client.isTalking)
		return;
	
	%client.isTalking = false;
	
	//tell the other clients who stopped talking
	for( %clientIndex = 0; %clientIndex < ClientGroup.getCount(); %clientIndex++ )
	{
		%cl = ClientGroup.getObject( %clientIndex );
		messageClient(%cl, 'MsgStopTalking', '', %client);
	}
}


function ServerCmdGetMOTD(%client)
{
   %motdLen = strLen($Pref::Server::MOTD);
   %offset = 0;

   commandToClient(%client, 'SetMOTD', 0, "");
   while(1)
   {
      if(%offset >= %motdLen)
         return;
      
      %subStr = getSubStr($Pref::Server::MOTD, %offset, 200);
      commandToClient(%client, 'SetMOTD', 1, %subStr);
      %offset += 200;
   }  
}