//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Hook into the mission editor.

function StaticShapeData::create(%data)
{
   // The mission editor invokes this method when it wants to create
   // an object of the given datablock type.
   %obj = new StaticShape() {
      dataBlock = %data;
   };
   return %obj;
}


function StaticShape::onAdd(%obj)
{
   //this doesn't get called
   //echo("Staticshape onadd", %obj);
}


function StaticShapeData::onAdd(%data, %obj)
{  
   //this gets called
   //echo("StaticShapeData onadd", %obj);

   %classname = %data.className;
   if(%className !$= "")
      eval( %className @ "::onAdd(" @ %data @ "," @ %obj @ ");" );
//
//   //if this is a deployable that has limits, apply them
//   if(isObject(%obj.client))
//      TeamManager_SO.incDeployableCount(%obj.team, %data, 1);
}

function StaticShapeData::onRemove(%data, %obj)
{  
   //this gets called
   //echo("StaticShapeData onadd", %obj);

   %classname = %data.className;
   if(%className !$= "")
      eval( %className @ "::onRemove(" @ %data @ "," @ %obj @ ");" );

   //if this is a deployable that has limits, apply them
   if(isObject(%obj.client))      
      TeamManager_SO.incDeployableCount(%obj.team, %data, -1);
}


function StaticShapeData::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
   echo("staticshapeData:: damage");

   %obj.applyDamage(%damage);

   if(%obj.getDamageLevel() >= %this.maxDamage)
      %obj.explode();
}

function StaticShape::explode(%obj)
{  
   //echo("staticshapeData::explode ", %obj);
   %obj.getDataBlock().explode(%obj);
}
function StaticShapeData::Explode(%data, %obj)
{
   //echo("staticshapeData::explode ", %this, "|", %obj);
   
   //make a new projectile / explosion / whatever

   
   TeamManager_SO.incDeployableCount(%obj.team, %data, -1);

   //delete the object
   %obj.schedule(10, delete);
}