//team.cs

function initTeams()
{
   if(isObject(TeamManager_SO))
      TeamManager_SO.delete();

   new ScriptObject(TeamManager_SO)
   {
      className = TeamManager_SO;
      numTeams = 0;
   };


   %mainGroup = Game_CTF.getID();
   %count = %mainGroup.getCount();

   for(%i = 0; %i < %count; %i++)
   {
      %obj = %mainGroup.getObject(%i);

      if(%obj.getClassName() $= "SimGroup")
      {
         %name = %obj.getName();
         %teamName = getSubStr(%name, 5, strLen(%name) - 5);
         //echo("team name = ", %teamName);
         TeamManager_SO.addTeam(%teamName, %obj);
      }
      else
      {
         //process everything in the game folder
         %obj.GamePreProcess();
      }
   }
   TeamManager_SO.teamName[999] = "Observer";

   TeamManager_SO.teamScoreCap = mFloor(%mainGroup.teamScoreCap);
   if(TeamManager_SO.teamScoreCap <= 0)
      TeamManager_SO.teamScoreCap = $Game::TeamScoreCap;

   TeamManager_SO.TransmitTeamsToAll();
}


function TeamManager_SO::AddTeam(%this, %teamName, %teamGroup)
{
   %this.teamName[%this.numTeams] = %teamName;
   %this.teamGroup[%this.numTeams] = %teamGroup;
   %this.teamScore[%this.numTeams] = 0;
   %this.teamPlayerCount[%this.numTeams] = 0;
   %this.flagList[%this.numTeams] = "";

   //all the objects inside the team group need to have their .team field set
   %count = %teamGroup.getCount();
   for(%i = 0; %i < %count; %i++)
   {
      %obj = %teamGroup.getObject(%i);
      %obj.team = %this.numTeams;

      %obj.gamePreProcess();

//      if(%obj.getType() & $TypeMasks::ItemObjectType)
//      {
//         if(%obj.getDataBlock().className $= "Flag")
//         {
//            %this.hasFlag[%this.numTeams] = true;
//            %this.flagList[%this.numTeams] = %this.flagList[%this.numTeams] SPC %obj;
//         }
//      }
   }
//   %this.flagList[%this.numTeams] = trim(%this.flagList[%this.numTeams]);

   %this.numTeams++;
}

function TeamManager_SO::AddFlag(%this, %obj)
{
   if(%obj.team !$= "" && %obj.team != -1)
   {
      %this.hasFlag[%obj.team] = true; 
      %this.flagList[%obj.team] = trim(%this.flagList[%obj.team] SPC %obj);
   }
   else
   {
      %this.flagList = trim(%this.flagList SPC %obj);
   }
}

function DumpTeams()
{
   TeamManager_SO.dumpTeams();
}

function TeamManager_SO::dumpTeams(%this)
{
   echo("");
   echo(%this.numTeams @ " teams:");

   for(%i = 0; %i < %this.numTeams; %i++)
   {
      echo("  " @ %i @ " : " @ %this.teamName[%i]);
      echo("    " @ %this.teamScore[%i] @ " points");
      echo("    " @ %this.teamPlayerCount[%i] @ " players");
      echo("    hasflag: " @ %this.hasFlag[%i]);
      echo("      flags: " @ %this.flagList[%i]);
   }
   echo("Neutral 'Flags':", %this.flagList);
   echo("");
}

function TeamManager_SO::TransmitTeamsToAll(%this)
{
   %group = ClientGroup.getID();
   %count = %group.getCount();
   for(%i = 0; %i < %count; %i++)
   {
      %cl = %group.getObject(%i);
      %this.TransmitTeams(%cl);
   }
}

//tell everyone about the teams
function TeamManager_SO::TransmitTeams(%this, %client)
{
   %teams = "";
   %scores = "";
   for(%i = 0; %i < %this.numTeams; %i++)
   {
      %teams = %teams TAB %this.teamName[%i];
      %scores = %scores TAB %this.teamScore[%i];
   }
   %teams = trim(%teams);
   %scores = trim(%scores);

   commandToClient(%client, 'SetTeams', %teams, %scores);
   
   //tell client what team objects we're going to have
   //if we're going to support multiple flags per team, this will have to be more complicated
   commandToClient(%client, 'ShowFlagStatus', true);
   commandToClient(%client, 'ResetFlagList');

   //send team flags
   %flagList = "";
   for(%i = 0; %i < %this.numTeams; %i++)
   {
      %wordCount = getWordCount(%this.flagList[%i]);
      for(%j = 0; %j < %wordCount; %j++)
      {
         %flagID = getWord(%this.flagList[%i], %j);

         //send status
         %flagID.transmitStatus(%client);

         //send name
         commandToClient(%client, 'SetFlagName', %flagID, %flagID.getName());

         //%teamNumber = %i;
         //%flagName = %flagID.getName();
         //%status = %flagID.status;

         //%flagList = %flagList TAB %flagID SPC %status SPC %flagName SPC %teamNumber;
      }
   }

   //send neutral flags
   %wordCount = getWordCount(%this.flagList);
   for(%i = 0; %i < %wordCount; %i++)
   {
      %flag = getWord(%this.flagList, %i);
      %flag.transmitStatus(%client);
      commandToClient( %client, 'SetFlagName', %flag, %flag.getName());
   }

   //%flagList = trim(%flagList);
   //echo("Flag list = ", %flagList);
   //commandToClient(%client, 'SetFlagList', %flagList);
}

// ---------------------------------
// Joining and leaving teams
// ---------------------------------

function serverCmdSetSpawnTeam(%client, %teamNumber)
{
   %teamNumber = mFloor(%teamNumber);
   %client.spawnTeam = %teamNumber;

   if(%client.team == %client.spawnTeam)
      return;

   if(%client.team == 999)
      if(%client.spawnTeam == -1) //auto-join
         TeamManager_SO.clientAutoJoinTeam(%client);
      else
         TeamManager_SO.clientJoinTeam(%client, %teamNumber);
}

function serverCmdJoinTeam(%client, %teamNumber)
{  
   %teamNumber = mFloor(%teamNumber);

   //if(%client.team == %teamNumber)
   //   return;
      
   if(%client.team == 999)
   {
      if(%teamNumber != 999)
         TeamManager_SO.clientJoinTeam(%client, %teamNumber);
   }
   else
      %client.joinTeam(%teamNumber, $Game::TeamSwitchDelay);
}

function GameConnection::JoinTeam(%client, %teamNumber, %time)
{
   if(isEventPending(%client.joinTeamEvent))
      cancel(%client.joinTeamEvent);

   if(%time <= 0)
   {
      commandToClient(%client, 'ClearBottomPrint');
      TeamManager_SO.clientJoinTeam(%client, %teamNumber);
   }
   else
   {
      commandToclient(%client, 'BottomPrint', "Switching Teams in " @ mFloor(%time / 1000) , 2);
      %client.joinTeamEvent = %client.schedule(1000, JoinTeam, %teamNumber, %time - 1000);
   }
}

function TeamManager_SO::clientJoinTeam(%this, %client, %teamNumber)
{
   if( (%teamNumber >= %this.numTeams || %teamNumber < 0) && %teamNumber != 999) 
   {
      Error("Error: TeamManager_SO::clientJoinTeam() - Invalid team number " @ %teamNumber);
      return;
   }

   //leave old team
   if(%client.team !$= "")
      TeamManager_SO.clientLeaveTeam(%client);

   if(%teamNumber == 999)
   {
      messageClient(%client, 'InventoryReset');
      %client.team = %teamNumber;
      %client.setControlObject(%client.camera);
   }
   else
   {
      //team balancing checks go here?

      %client.team = %teamNumber;
      %client.spawnTeam = %client.team;

      %client.spawnPlayer();
      %this.teamPlayerCount[%teamNumber]++;
   }
   
   %color = %this.getTeamHexColor(%client.team);
   %name = stripMLControlChars(getTaggedString(%client.name));
   messageAll('MsgClientJoin', %color @ %name @ " joined team " @ %this.teamName[%client.team] , 
      %client.name, 
      %client,
      %client.team,
      %client.isAdmin);

   //tell the client what team they're on so they dont auto-join a team next time they spawn
  commandToClient(%client, 'SetYourTeam', %client.team);  
}

//player shows no team preference
function serverCmdAutoJoinTeam(%client)
{
   TeamManager_SO.clientAutoJoinTeam(%client);
}

function TeamManager_SO::clientAutoJoinTeam(%this, %client)
{
   //find the weakest team
      //lower player count, then lowest score

   %worstTeam            = 0;
   %worstTeamPlayerCount = 99999999;
   %worstTeamScore       = 99999999;

   for(%i = 0; %i < %this.numTeams; %i++)
   {
      if(%this.teamPlayerCount[%i] < %worstTeamPlayerCount)
      {
         %worstTeamPlayerCount = %this.teamPlayerCount[%i];
         %worstTeamScore = %this.teamScore[%i];
         %worstTeam = %i;
      }
      else if(%this.teamPlayerCount[%i] == %worstTeamPlayerCount)
      {
         if(%this.teamScore[%i] < %worstTeamScore)
         {
            %worstTeamScore = %this.teamScore[%i];
            %worstTeam = %i;
         }
      }
   }

   %this.clientJoinTeam(%client, %worstTeam);
}

//should be called when a client disconnects
function TeamManager_SO::clientLeaveTeam(%this, %client)
{
   if(%client.team $= "")
   {
      error("ERROR: TeamManager_SO::clientLeaveTeam() - client " @ %client @ " has no team");
      return;
   }

   if(%client.team >= %this.numTeams || %client.team < 0 && %client.team != 999) 
   {
      error("ERROR: TeamManager_SO::clientLeaveTeam() - client " @ %client @ " has invalid team number " @ %client.team);
      return;
   }

   %this.teamPlayerCount[%client.team]--;
   %client.team = 999;

   //if we have a player, remove it
   if(isObject(%client.player))
      %client.player.delete();
}

function TeamManager_SO::PickSpawnPoint(%this, %teamNumber)
{
   if(%teamNumber >= %this.numTeams)
      return;
   
   %teamGroup = %this.teamGroup[%teamNumber];
   %group = 0;

   %group = nameToID("MissionGroup/Game_CTF/Team_" @ %this.teamName[%teamNumber] @ "/SpawnPoints");

//   for(%i = 0; %i < %teamGroup.getCount(); %i++)
//   {
//      %obj = %teamGroup.getObject(%i);
//      if(%obj.getClassName() !$= "SimGroup")
//         continue;
//      if(%obj.getName() !$= "SpawnPoints")
//         continue;
//
//      %group = %obj;
//      break;
//   }
   
   if(!isObject(%group))
   {
      error("ERROR: TeamManager_SO::PickSpawnPoint() - SpawnPoints group not found for team " @ %teamNumber);
      return "0 0 300";
   }

   //radius + raycast down method from blockland
   %count = %group.getCount();

   if(%count == 0)
   {
      error("ERROR: TeamManager_SO::PickSpawnPoint() - No spawn points found in " @ %groupName);
      return("0 0 300");
   }

   %startIndex = getRandom(%count-1);

   for(%j = 0; %j  < %count; %j++)
   {
      %index = (%startIndex + %j) % %count;

      %spawn = %group.getObject(%index);
      //echo("spawn object = ", %spawn);

      %trans = %spawn.getTransform();
      
      //loop for radius spawns
      for(%i = 0; %i < 1000; %i++)
      {
         %transX = getWord(%trans, 0);
         %transY = getWord(%trans, 1);
         %transZ = getWord(%trans, 2);
         
         if(%spawn.radius)
         {
            %offsetX = (getRandom() * %spawn.radius * 2) - %r;
            %offsetY = (getRandom() * %spawn.radius * 2) - %r;

            if(vectorLen(%offsetX SPC %offsetY SPC 0) > %r)
               continue;
            
            %transX += %offsetX;
            %transY += %offsetY;
         }
          
         //raycast from z val - ray height down
         %start = %transX SPC %transY SPC %transZ ;
         %end   = %transX SPC %transY SPC %transZ - 10;
         %mask = $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType | $TypeMasks::PlayerObjectType;

         %scanTarg = containerRayCast(%start,%end,%mask,0);
         //error("scan targ = ", %scanTarg);
         
         if(%scanTarg)
         {
            %scanPos = posFromRaycast(%scanTarg);
            %transZ = getWord(%scanPos, 2);
            //error("scan pos = ", %scanPos);

            //require line of site to spawn center
            if(%spawn.radius)
               if(containerRayCast(%boxCenter, %trans, $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType))
                  continue; 

            //require an empty space big enough for the player
            %boxCenter = vectorAdd(%scanPos, "0 0 1.6");
            %boxClearMask = $TypeMasks::StaticObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::InteriorObjectType; 
            if(!containerBoxEmpty(%boxClearMask, %boxCenter, 0.6, 0.6, 1.3))
            {
               echo("spawnpoint boxclear failed");
               if(%spawn.radius)
                  continue;
               else
                  break;
            }
            
            %foundSpawn = true;
            break;
         }				
      }	//end radius spawn loop

      if(%foundSpawn)
         break;
   } //end loop through different spawnpoints

   if(!%foundSpawn)
   {
      //we've checked through all spawnpoints without finding an empty one
      //stack up on top of the first spawnpoint
      echo("did not find spawn point");
      %start = vectorAdd(%scanPos, "0 0 25");
      %end = vectorAdd(%scanPos, "0 0 -2");
      %mask = $TypeMasks::StaticObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::InteriorObjectType; 

      %scanTarg = containerRayCast(%start,%end,%mask,0);
      %scanPos = posFromRayCast(%scanTarg);
      %transX = getWord(%scanPos,0);
      %transY = getWord(%scanPos,1);
      %transZ = getWord(%scanPos,2);
   }
   
   if(%spawn.directional)
      %spawnAngle = " " @ getWords(%spawn.getTransform(), 3, 6);
   else
      %spawnAngle = " 0 0 1 " @ getRandom($pi * 2 * 100) / 100;

   %returnTrans = %transX  @ " " @ %transY @ " " @ %transZ @ %spawnAngle;
   
   return %returnTrans;
   //return %spawn.getTransform();



//   %count = %group.getCount();
//   if (%count != 0) {5/9/2007
//      %index = getRandom(%count-1);
//      %spawn = %group.getObject(%index);
//      return %spawn.getTransform();
//   }
//   else
//      error("No spawn points found in SpawnPointsGroup for team " @ %teamNumber);
}


// ---------------------------------
// Scoring
// ---------------------------------

function TeamManager_SO::IncScore(%this, %teamNumber, %amt)
{
   if(%teamNumber >= %this.numTeams || %teamNumber < 0) 
   {
      error("ERROR: TeamManager_SO::IncScore() - invalid team number \"" @ %teamNumber @ "\"");
      return;
   }

   %this.teamScore[%teamNumber] += %amt;
   
   //tell everyone
   messageAll('TeamScore', '', %teamNumber, %this.teamScore[%teamNumber]);
   
   if(%this.teamScore[%teamNumber] >= %this.teamScoreCap)
      cycleGame();
}


// ---------------------------------
// Damage permissions
// ---------------------------------

function TeamManager_SO::CanDamage(%this, %attackerObject, %victimObject)
{
   %teamA = getTeamFromObject(%attackerObject);
   %teamV = getTeamFromObject(%victimObject);

   if(%teamA == -1 || %teamV == -1)
      return true;

   //self damage?
   if(getClientFromObject(%attackerObject) == getClientFromObject(%victimObject))
      return $Pref::Server::SelfDamage;

   //team damage?
   if(%teamA == %teamV)
      return $Pref::Server::TeamDamage;

   //regular damage
   return true;
}

function getTeamFromObject(%obj)
{
   if(%obj.team !$= "")
      return(%obj.team);
     
   if(isObject(%obj.client))
      return(%obj.client.team);
   else
      return -1;
}

function getClientFromObject(%obj)
{
   if(%obj.getClassName() $= "GameConnection")
      return %obj;
   
   if(isObject(%obj.client))
      return(%obj.client);
}  


function TeamManager_SO::getTeamHexColor(%this, %team)
{
   switch(%team)
   {
      case 0:
         return "<color:FF4040>";
      case 1:
         return "<color:4040FF>";
      case 999:   
         return "<color:FFFFFF>";
      default:
         return "<color:FF00FF>";
   }
}

function TeamManager_SO::getTeamShapeNameColor(%this, %team)
{
   switch(%team)
   {
      case 0:
         return "1 0.25 0.25 1";
      case 1:
         return "0.25 0.25 1 1";
      case 999:   
         return "1 1 1 1";
      default:
         return "0.25 0.25 0.25 1";
   }
}


function TeamManager_SO::getDeployableCount(%this, %team, %deployableData)
{
   //make sure we have the number, not the name
   %deployableData = %deployableData.getID();

   return (mFloor(%this.deployableCount[%team, %deployableData]));
}

function TeamManager_SO::incDeployableCount(%this, %team, %deployableData, %amount)
{
   //make sure we have the number, not the name
   %deployableData = %deployableData.getID();

   %this.deployableCount[%team, %deployableData] += %amount;
}

function TeamManager_SO::canDeploy(%this, %team, %deployableData)
{
   //make sure we have the number, not the name
   %deployableData = %deployableData.getID();

   //compare current count with limit
   %amt = mFloor(%this.deployableCount[%team, %deployableData]);
   %limit = mFloor( $Game::DeployableLimit_Team[%deployableData] );

   if(mFloor($Game::DeployableLimit_Team[%deployableData]) > 0)
   {
      if(%amt >= %limit)
         return false;
      else
         return true;
   }
   else
   {
      return true;
   }
}