datablock ParticleData(LaserAExplosionParticle1)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -2;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 300;
	textureName          = "~/data/textures/effects/particle/flame01";
	spinSpeed		= 0.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.2 0.2 0.9";
	colors[1]     = "1 0.0 0.0 0.0";
	sizes[0]      = 1.5;
	sizes[1]      = 0.2;
};
datablock ParticleEmitterData(LaserAExplosionEmitter1)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 12;
   velocityVariance = 8.0;
   ejectionOffset   = 0.0;
   ejectionOffsetVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LaserAExplosionParticle1";
};


datablock ParticleData(LaserAExplosionParticle2)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -1.5;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 300;
	textureName          = "~/data/textures/effects/particle/flame01";
	spinSpeed		= 0.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.8 0.4 0.9";
	colors[1]     = "1 0.0 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.5;
};
datablock ParticleEmitterData(LaserAExplosionEmitter2)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   ejectionOffsetVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LaserAExplosionParticle2";

   lifeTimeMS = 100;
};
datablock ExplosionData(LaserAExplosion)
{
   explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 250;

   emitter[0] = LaserAExplosionEmitter2;

   particleEmitter = LaserAExplosionEmitter1;
   particleDensity = 75;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 0;
   lightStartColor = "1 0 0";
   lightEndColor = "0 0 0";
};

datablock LinearProjectileData( LaserAProjectile )
{
    projectileShapeName  = "~/data/shapes/weapons/disc_proj.dts";
    scale                = "2.4 2.4 2.4";

    sound                = DiscLauncherProjectileSound;
    explosion            = LaserAExplosion;
//    particleEmitter      = DiscLauncherTrailEmitter;

    directDamage         = 90;
       doLocationDamage  = true;
       directDamageHead  = 90;
       directDamageTorso = 75;
       directDamageLegs  = 60;
    radiusDamage         = 0;
    damageRadius         = 0;
    damageType           = $DamageType::Laser;
    impulseForce         = 0;
    impulseVertical      = 0;
    impulseRadius        = 0;

    muzzleVelocity       = 163;//133; //123
    velInheritFactor     = 0.75;

    lifetime             = 6500;
    fadeDelay            = 1500;

    hasLight             = true;
    lightRadius          = 5.0;
    lightColor           = "1 0.4 0.3";
};