

datablock ParticleData(ChaingunImpactSmokeParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/textures/effects/particle/smoke01";
   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.7 0.7 0.7 0.4";
   colors[2]     = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ChaingunImpactSmoke)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 35;
   overrideAdvances = false;
   particles = "ChaingunImpactSmokeParticle";
   lifetimeMS       = 50;
};


datablock ParticleData(ChaingunSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 0;
   textureName          = "~/data/textures/effects/particle/spark02";
   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "1.0 0.36 0.26 0.0";
   sizes[0]      = 0.6;
   sizes[1]      = 0.2;
   sizes[2]      = 0.05;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(ChaingunSparkEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 50;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "ChaingunSparks";
};


datablock ExplosionData(ChaingunExplosion)
{
   soundProfile   = ChaingunImpact;

   emitter[0] = ChaingunImpactSmoke;
   emitter[1] = ChaingunSparkEmitter;

   faceViewer           = false;
};

datablock LinearProjectileData(ChaingunBullet)
{
   projectileShapeName  = "~/data/shapes/weapons/disc_proj.dts";
   scale                = "0.4 2.4 0.4";
    
   doClientHitPredict = true;

   directDamage        = 12;
   directDamageType    = $DamageType::Bullet;

   radiusDamage         = 0;
   damageRadius         = 0;
   impulseForce         = 0;
   impulseVertical      = 0;
   impulseRadius        = 0;

   explosion = bulletMetalExplosion;
   sound = ChaingunProjectile;

   muzzleVelocity = 500.0;
   velInheritFactor = 1.0;

   lifetime = 3000;
   explodeOnDeath = false;

   lightRadius = 0;
   lightColor = "0 0 0 0";
};

datablock DebrisData( ShellDebris )
{
    shapeFile             = "~/data/shapes/weapons/disc_shell.dts";

    lifetime              = 5.0;
    minSpinSpeed          = 300.0;
    maxSpinSpeed          = 400.0;

    elasticity            = 0.7;
    friction              = 0.2;
    numBounces            = 3;

    staticOnMaxBounce     = true;
    snapOnMaxBounce       = false;
    fade                  = true;
};   

// -----------------------------------------------------------------------------

datablock ItemData(ChaingunAmmo)
{
   className = "Ammo";
   category = "Ammo";
   
   shapeFile = "~/data/shapes/weapons/chaingun_ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   
   throwForce = 1000;
   
   inventoryName = "Chaingun Ammo";
   maxInventory = 100;
   weapon = Chaingun;
   
   regenDelay = 3000;
   energyUsage = 0;

   computeCRC = true;
};

// -----------------------------------------------------------------------------

datablock ItemData(Chaingun)
{
   className = "Weapon";
   category = "Weapon";
   
   clientProfile = "Chaingun";
   
   shapeFile    = "~/data/shapes/weapons/chaingun_wep.dts";
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   emap = true;

   inventory = true;
   inventoryName = "Chaingun";
   hudName = "Chain";
   inventoryRequirement = "";
   inventoryDescription = "";
   iconName = "chainGun";
   
   computeCRC = true;
   
   throwForce = 1500;
   
   image = ChaingunImage;
   ammo = ChaingunAmmo;
};

datablock ShapeBaseImageData(ChaingunImage)
{
   className = "WeaponImage";
   shapeFile = "~/data/shapes/weapons/chaingun_wep.dts";
   mountPoint = $WeaponSlot;
   
   firstPerson = true;
   emap = true;
      
   projectileType = LinearProjectile;
   item = Chaingun;
   casing = ShellDebris;
   ammo = ChaingunAmmo;
   projectile = ChaingunBullet;
   
   projectileSpread = 8.0 / 1000.0;
   correctMuzzleVector = true;

   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 3.0;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateSound[0]            = ChaingunSwitchSound;
   stateAllowImageChange[0] = false;
   //
   stateTimeoutValue[0]        = 0.5;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";

   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   //
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";

   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";

   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateSound[3]        = ChaingunSpinupSound;
   //
   stateTimeoutValue[3]          = 0.5;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";

   //--------------------------------------
   stateName[4]             = "Fire";
   stateSequence[4]            = "Fire";
   stateSequenceRandomFlash[4] = true;
   stateSpinThread[4]       = FullSpeed;
   stateSound[4]            = ChaingunFireSound;
   //stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateEjectShell[4]       = true;
   //
   stateTimeoutValue[4]          = 0.15;
   stateTransitionOnTimeout[4]   = "Fire";
   stateTransitionOnTriggerUp[4] = "Spindown";
   stateTransitionOnNoAmmo[4]    = "EmptySpindown";

   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSound[5]      = ChaingunSpinDownSound;
   stateSpinThread[5] = SpinDown;
   //
   stateTimeoutValue[5]            = 1.0;
   stateWaitForTimeout[5]          = true;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";

   //--------------------------------------
   stateName[6]       = "EmptySpindown";
   stateSound[6]      = ChaingunSpinDownSound;
   stateSpinThread[6] = SpinDown;
   //
   stateTimeoutValue[6]        = 0.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
   
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ChaingunDryFireSound;
   stateTimeoutValue[7]        = 0.5;
   stateTransitionOnTimeout[7] = "NoAmmo";
};

