//grenade.cs

//generic scripts for hand grenade/satchel charge type items

function Grenade::onUse(%data, %player, %InvPosition)
{
   //echo("Grenade::OnUse ", %player);
   //decrement inventory

   %thrownItem = new Item()
   {
      datablock = %data;
      rotation = "0 0 1 " @ (getRandom() * 360);
      count = 1;
   };
   MissionCleanup.add(%thrownItem);
   %thrownItem.setCollisionTimeout(%player);
   
   %thrownItem.setTransform(%player.getWorldBoxCenter());

   %vector = %player.getEyeVector();
   %vector = vectorAdd(%vector, "0 0 0.5");
   %vector = vectorNormalize(%vector);
   %vector = vectorScale(%vector, 15);
   %vector = vectorAdd(%vector, %player.getVelocity());
   %thrownItem.setVelocity(%vector);

   %player.decInventory(%data, 1);

   %thrownItem.mountImage(%data.grenadeImage, 0);
   %thrownItem.schedule(%data.grenadeTime, explode);
   %thrownItem.cantPickup = true;

   return %thrownItem;
}

function Grenade::explode(%data, %obj)
{
   %p = new GrenadeProjectile()
   {
      datablock = %data.grenadeProjectile;
      InitialPosition = %obj.getPosition();
      InitialVelocity = "0 0 0";
      sourceClient = %obj.client;
   };
   MissionCleanup.add(%p);

   %obj.delete();
}

function Grenade::onPickup(%this,%obj,%user,%amount)
{
   //cant pick up grenades
   return;
}