//--------------------------------------
// Grenade launcher
//--------------------------------------

datablock ParticleData(GrenadeSmokeParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.2;   // rises slowly
   inheritedVelFactor   = 0.05;

   lifetimeMS           = 700;  // lasts 2 second
   lifetimeVarianceMS   = 150;   // ...more or less

   textureName          = "~/data/textures/effects/particle/smoke02";

   useInvAlpha = true;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.9 0.9 0.9 1.0";
   colors[1]     = "0.6 0.6 0.6 1.0";
   colors[2]     = "0.4 0.4 0.4 0.0";

   sizes[0]      = 0.25;
   sizes[1]      = 1.0;
   sizes[2]      = 3.0;

   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(GrenadeSmokeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 5;

   ejectionVelocity = 1.25;
   velocityVariance = 0.50;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = "GrenadeSmokeParticle";
};

datablock GrenadeProjectileData(BasicGrenade)
{
   projectileShapeName = "~/data/shapes/weapons/disc_shell.dts";
   scale = "1 1 1";
    
   directDamage         = 5;
   radiusDamage         = 85;
   damageRadius         = 15;
   damageType           = $DamageType::Grenade;
   impulseForce         = 1000;
   impulseVertical      = 1000;
   impulseRadius        = 15;

   sound = GrenadeProjectileSound;
   explosion = GenericLargeExplosion; //GroundMinorExplosion;
   emitter = GrenadeSmokeEmitter;
   
   muzzleVelocity = 100.00;
   velInheritFactor = 0.5;

   gravityMod = 5;
   elasticity = 0.25;
   friction = 0.25;
   armingDelay = 650;
   drag = 0.0;
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(GrenadeLauncherAmmo)
{
   className = "Ammo";
   category = "Ammo";
   shapeFile = "~/data/shapes/weapons/mortar_ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some grenade launcher ammo";
   
   computeCRC = true;
   emap = true;
   
   throwforce = 1000;
   regendelay = 5000;
   weapon = GrenadeLauncher;
   Inventoryname = "Grenade Launcher Ammo";
   maxInventory     = 5;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(GrenadeLauncher)
{
   className = "Weapon";
   category = "Weapon";
   
   shapeFile = "~/data/shapes/weapons/grenadel_wep.dts";
   image = GrenadeLauncherImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

   inventory = true;
   inventoryName = "Grenade Launcher";
   hudName = "Grenade Launcher";
   inventoryRequirement = "";
   inventoryDescription = "";
   iconName = "grenadeLauncher";

   computeCRC = true;

   throwforce = 1500;
   
   pickUpName = "a grenade launcher";
   ammo = GrenadeLauncherAmmo;
};

datablock ShapeBaseImageData(GrenadeLauncherImage)
{
   className = "WeaponImage";
   shapeFile = "~/data/shapes/weapons/grenadel_wep.dts";
   item = GrenadeLauncher;
   ammo = GrenadeLauncherAmmo;

   emap = true;

   projectile = BasicGrenade;
   projectileType = GrenadeProjectile;
   
   usesEnergy = false;
   minenergy = 0;
   
   firstPerson = true;
   correctMuzzleVector = true;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = GrenadeSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.4;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3] = "onFire";
   stateSound[3] = GrenadeFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.5;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = GrenadeReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = GrenadeDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
};
