//handGrenade.cs



datablock GrenadeProjectileData(handGrenadeProjectile)
{
   //projectileShapeName = "~/data/shapes/weapons/disc_shell.dts";
   scale = "1 1 1";
    
   directDamage         = 5;
   radiusDamage         = 85;
   damageRadius         = 15;
   damageType           = $DamageType::Grenade;
   impulseForce         = 1000;
   impulseVertical      = 1000;
   impulseRadius        = 15;

   sound = GrenadeProjectileSound;
   explosion = GenericLargeExplosion; //GroundMinorExplosion;
   emitter = GrenadeSmokeEmitter;
   
   muzzleVelocity = 0.00;
   velInheritFactor = 1.0;

   gravityMod = 1;
   elasticity = 0.25;
   friction = 0.25;
   armingDelay = 0;
   drag = 0.0;

   lifetime = 100;
};


datablock ParticleData(HandGrenadeSmokeParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.2;   // rises slowly
   inheritedVelFactor   = 0.05;

   lifetimeMS           = 700;  // lasts 2 second
   lifetimeVarianceMS   = 150;   // ...more or less

   textureName          = "~/data/textures/effects/particle/smoke02";

   useInvAlpha = true;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.9 0.9 0.9 0.2";
   colors[1]     = "0.6 0.6 0.6 0.2";
   colors[2]     = "0.4 0.4 0.4 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 1.0;
   sizes[2]      = 1.0;

   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(HandGrenadeSmokeEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 4;

   ejectionVelocity = 1.25;
   velocityVariance = 0.50;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = "HandGrenadeSmokeParticle";
};

datablock ParticleData(HandGrenadeSparkParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 0.5;   
   inheritedVelFactor   = 0.05;

   lifetimeMS           = 100; 
   lifetimeVarianceMS   = 50;

   textureName          = "~/data/textures/effects/particle/spark02";

   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.9 0.9 0.3 0.9";
   colors[1]     = "0.6 0.6 0.3 0.9";
   colors[2]     = "0.4 0.4 0.0 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 1.0;
   sizes[2]      = 1.0;

   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(HandGrenadeSparkEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 4;

   ejectionVelocity = 15.25;
   velocityVariance = 0.50;

   thetaMin         = 0.0;
   thetaMax         = 180.0;  

   orientParticles = true;

   particles = "HandGrenadeSparkParticle";
};

datablock ShapeBaseImageData(handGrenadeImage)
{
   shapeFile = "~/data/shapes/weapons/empty.dts";

   stateName[0] = "Smoke";
   stateEmitter[0] = HandGrenadeSmokeEmitter;
   stateEmitterTime[0] = 2;
   stateTimeoutValue[0] = 2;
   stateTransitionOnTimeout[0] = "Spark";

   stateName[1] = "Spark";
   stateEmitter[1] = HandGrenadeSparkEmitter;
   stateEmitterTime[1] = 1.5;
   stateTimeoutValue[1] = 1.5;
   stateTransitionOnTimeout[1] = "Spark";
};



datablock ItemData(handGrenade)
{
   className = "Grenade";
   category = "Grenade";

   dynamicType      = $TypeMasks::DamagableItemObjectType;
   
   shapeFile = "~/data/shapes/weapons/mortar_ammo.dts";
   mass = 75;
   elasticity = 0.2;
   friction = 0.6;
   
   throwForce = 1000;
   
   inventoryName = "Hand Grenade";
   maxInventory = 100;
   iconName = "Grenade";
   
   regenDelay = 3000;
   energyUsage = 0;

   computeCRC = true;

   grenadeTime = 2500;
   grenadeProjectile = handGrenadeProjectile;
   grenadeImage = handGrenadeImage;
};