//healthStationGun.cs

//engineer item
//deploys a health station
//health station heals team mates when they are near by

datablock StaticShapeData(HealthStation)
{
	category = "Deployable";   // Mission editor category

	className = "PulseObject";      
	shapeFile = "~/data/shapes/items/flag_red.dts";
	eMap = false;	
		
	isShielded = true;
	energyPerDamagePoint = 110;
	maxEnergy = 50;
	rechargeRate = 0.20;
	renderWhenDestroyed = false;
	doesRepair = true;

   //deployable stuff
   dynamicType    = $TypeMasks::StationObjectType;
	deployedObject = true;
   explosionSound = glassExplosionSound;
   
   maxDamage      = 100;
	disabledLevel  = 80;
	explosion      = glassExplosion;
	expDmgRadius   = 8.0;
	expDamage      = 0.35;
	expImpulse     = 500.0;

   //placement constraints
   maxSlope       = 360;    // maximum slope you can deploy on
   alignToNormal  = true;  //
   playerClearRadius = 1;  // cannot be any players within this radius
   staticClearRadius = 0.2;     // 


   //pulseObject stuff
   pulseTime = 500;
};

$Game::DeployableLimit_Player[HealthStation.getID()] = 5;
$Game::DeployableLimit_Team[HealthStation.getID()] = 5;

// -----------------------------------------------------------------------------
// -- Ammunition
// -----------------------------------------------------------------------------

datablock ItemData( HealthStationGunAmmo )
{
    category         = "Ammo";
    className        = "Ammo";

    shapeFile        = "~/data/shapes/weapons/disc_shell.dts";
    mass             = 80;
    elasticity       = 0.2;
    friction         = 0.6;

    throwForce       = 1000;

    //pickUpName       = "disc launcher ammo";
    inventoryName    = "Health Station Ammo";
    maxInventory     = 5;
    weapon           = TurretGun;
    regendelay       = 3000;
    energyUsage      = 15;
};

datablock ParticleData(HealthStationGunBeamParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 0;
	textureName          = "~/data/textures/effects/particle/heart";
	spinSpeed		= 0.0;
	spinRandomMin		= -0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "1 0.0 0.3 1.0";
	colors[1]     = "1 0.0 0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.2;
};
datablock ParticleEmitterData(HealthStationGunBeamEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 100;
   velocityVariance = 0.0;
   ejectionOffset   = -2;
   ejectionOffsetVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HealthStationGunBeamParticle";

   blendStyle = 2;
};



datablock ItemData( HealthStationGun )
{
    category             = "Weapon";
    className            = "Weapon";
    
    // -- dont pay any attention to this variable UNLESS this is a mod weapon
    //    this value associates a weapon icon and reticle with this weapon.
    //    note that the BASE client only contains associations for base weapons.
    //    this means that server side mods should only use profiles for base weapons.
    clientProfile        = "HealthStationGun";
    
    shapeFile            = "~/data/shapes/weapons/disc_wep.dts";
    mass                 = 100;
    elasticity           = 0.2;
    friction             = 0.6;
    emap                 = true;

    inventory            = true;
    inventoryName        = "Health Station Gun";
    hudName              = "Health Station Gun";
    inventoryRequirement = "";
    inventoryDescription = "";
    iconName = "HealthKit";
    
    computeCRC           = $pref::Server::checkCRC;

    throwForce           = 1500;

    //pickUpName           = "a disc launcher";
    image                = HealthStationGunImage;
    ammo                 = HealthStationGunAmmo;
};

// -----------------------------------------------------------------------------

datablock ShapeBaseImageData( HealthStationGunImage )
{
    className                        = "WeaponImage";
    shapeFile                        = "~/data/shapes/weapons/disc_wep.dts";
    mountPoint                       = $WeaponSlot;

    //                                 +R/-L | +F/-B | +U/-D
    //offset                           = "0.15 -0.40 0.00";
    eyeOffset                        = "0.25 0.43 -0.34";
    rotation                         = "1 0 0 0";
    eyeRotation                      = "1 0 0 0";
    //scale = "0.5 0.5 0.5";

    usesEnergy                       = false;
    minEnergy                        = 0;

    lightType                        = "NoLight";
    lightColor                       = "1.000000 1.000000 1.000000 1.000000";
    lightTime                        = "1000";
    lightRadius                      = "10";

    shellExitDir                     = "0.707107 0 0.707107";
    shellExitVariance                = "20";
    shellVelocity                    = "5";

    cloakable                        = true;
    correctMuzzleVector              = true;
    emap                             = true;
    firstPerson                      = true;

    projectileType                   = LinearProjectile;  
    item                             = HealthStationGun;
    casing                           = "";
    ammo                             = HealthStationGunAmmo;
    projectile                       = "";
    projectileSpread                 = 0/1000;
    
    // ----

    stateName[0]                     = "PreActivate";
    stateTransitionOnLoaded[0]       = "CheckAmmo";

    stateName[1]                     = "Activate";
    stateTransitionOnTimeout[1]      = "Ready";
    stateTimeoutValue[1]             = 0.725;
    stateSequence[1]                 = "ready";
    stateSound[1]                    = "ShotgunMountSound";

    stateName[2]                     = "Ready";
    stateTransitionOnNoAmmo[2]       = "Noammo";
    stateTransitionOnTriggerDown[2]  = "Fire";
    stateSequence[2]                 = "ready";
    stateSound[2]                    = "ShotgunIdleSound";
    stateTimeoutValue[2] = 1;
    stateTransitionOnTimeout[2] = "Ready2";
    stateEmitter[2] = "HealthStationGunBeamEmitter";
    stateEmitterTime[2] = 1;
    stateWaitForTimeout[2] = false;

    stateName[9]                     = "Ready2";
    stateTransitionOnNoAmmo[9]       = "Noammo";
    stateTransitionOnTriggerDown[9]  = "Fire";
    stateSequence[9]                 = "ready";
    stateSound[9]                    = "ShotgunIdleSound";
    stateTimeoutValue[9] = 1;
    stateTransitionOnTimeout[9] = "Ready";
    stateEmitter[9] = "HealthStationGunBeamEmitter";
    stateEmitterTime[9] = 1;
    stateWaitForTimeout[9] = false;

    stateName[3]                     = "Fire";
    stateTransitionOnTimeout[3]      = "Reload";
    stateTimeoutValue[3]             = 0.01;
    stateFire[3]                     = true;
    stateRecoil[3]                   = LightRecoil;
    stateAllowImageChange[3]         = false;
    stateSequence[3]                 = "Fire";
    stateScript[3]                   = "onFire";
    stateEjectShell[3]               = true;
    stateSound[3]                    = "ShotgunFireSound";
    stateEmitter[3] = ShotgunFlashEmitter;
    stateEmitterNode[3] = "muzzleNode";
    stateEmitterTime[3] = 0.1;

    stateName[4]                     = "Reload";
    stateTransitionOnAmmo[4]         = "doReload";
    stateTransitionOnNoAmmo[4]       = "NoAmmo";
    stateAllowImageChange[4]         = false;

    stateName[5]                     = "Noammo";
    stateTransitionOnAmmo[5]         = "doReload";
    stateSequence[5]                 = "Noammo";
    stateTransitionOnTriggerDown[5]  = "DryFire";

    stateName[6]                     = "Dryfire";
    stateSound[6]                    = "ShotgunDryfireSound";
    stateTimeoutValue[6]             = 1.0;
    stateSequence[6]                 = "Noammo";
    stateTransitionOnTimeout[6]      = "Noammo";

    stateName[7]                     = "CheckAmmo";
    stateTransitionOnAmmo[7]         = "Ready"; //"Activate";
    stateTransitionOnNoAmmo[7]       = "NoAmmo";
  
    stateName[8]                     = "doReload";
    stateTransitionOnTimeout[8]      = "Ready";
    stateTimeoutValue[8]             = 0.725;
    stateSequence[8]                 = "Reload";
    stateSound[8]                    = "ShotgunReloadSound";
    stateAllowImageChange[8]         = false;
};

// -----------------------------------------------------------------------------
// -- Functions
// -----------------------------------------------------------------------------

function HealthStationGunImage::onFire(%data, %player, %slot)
{
   if(%player.invincible)
      %player.schedule(150, setInvincible, false);
   %client = %player.client;

   %hs = %player.deploy(%data, HealthStation);
   %hs.mountImage(healthStationImage, 0);
}  

function PulseObject::onAdd(%data, %obj)
{
   echo("Pulseobject::onadd ", %data, "|", %obj);
   %obj.pulse();
}

function PulseObject::onRemove(%data, %obj)
{
   echo("Pulseobject::onremove ", %data, "|", %obj);
}

function PulseObject::Pulse(%data, %obj)
{
   if(isEventPending(%obj.pulseEvent))
      cancel(%obj.pulseEvent);
   
   %obj.onPulse();

   %obj.pulseEvent = %obj.schedule(%data.pulseTime, pulse);
}

function HealthStation::onPulse(%data, %obj)
{

   //iterate through players, see if any of them are near by 
   //heal them if they are on our team
   %pos = %obj.getPosition();
   %count = clientGroup.getCount();
   for(%i = 0; %i < %count; %i++)
   {
      %client = clientGroup.getObject(%i);
      %player = %client.player;
      if(!isObject(%player))
         continue;

      if(%player.team != %obj.team)
         continue;

      %playerPos = %player.getPosition();
      %dist = vectorLen(vectorSub(%pos, %playerPos));
      if(%dist > 5)
         continue;

      %player.applyRepair(10);
   }

}



//health station area emitter effect
datablock ParticleData(healthStationParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 0.0;   
   inheritedVelFactor   = 0.0;

   lifetimeMS           = 250;  
   lifetimeVarianceMS   = 50;  

   textureName          = "~/data/textures/effects/particle/heart";

   useInvAlpha = false;
   spinRandomMin = -10.0;
   spinRandomMax = 10.0;

   colors[0]     = "1 0.3 0.3 1.0";
	colors[1]     = "1 0.0 0.3 1.0";
   colors[2]     = "1 0 0 0.0";

   sizes[0]      = 0.0;
   sizes[1]      = 1.0;
   sizes[2]      = 0.0;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};
datablock ParticleEmitterData(healthStationEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0;

   ejectionOffset = 5;

   thetaMin         = 0.0;
   thetaMax         = 180.0;  

   phiVariance = 10;
   phiReferenceVel = 200;

   particles = "healthStationParticle";
};


datablock ShapeBaseImageData(healthStationImage)
{
   shapeFile = "~/data/shapes/weapons/disc_shell.dts";

   offset = "0 0 0.5";

   rotation = "1 0 0 90";

   stateName[0] = "EmitA";
   stateEmitter[0] = healthStationEmitter;
   stateEmitterTime[0] = 7;
   stateTimeoutValue[0] = 7;
   stateTransitionOnTimeout[0] = "EmitB";

   stateName[1] = "EmitB";
   stateEmitter[1] = healthStationEmitter;
   stateEmitterTime[1] = 2;
   stateTimeoutValue[1] = 2;
   stateTransitionOnTimeout[1] = "EmitA";
};