//satchelcharge.cs

//like a grenade, but blows up bigger and after 30 seconds

datablock GrenadeProjectileData(satchelChargeProjectile)
{
   //projectileShapeName = "~/data/shapes/weapons/disc_shell.dts";
   scale = "1 1 1";
    
   directDamage         = 5;
   radiusDamage         = 85;
   damageRadius         = 15;
   damageType           = $DamageType::Grenade;
   impulseForce         = 1000;
   impulseVertical      = 1000;
   impulseRadius        = 15;

   sound = GrenadeProjectileSound;
   explosion = GenericLargeExplosion; //GroundMinorExplosion;
   emitter = GrenadeSmokeEmitter;
   
   muzzleVelocity = 0.00;
   velInheritFactor = 1.0;

   gravityMod = 1;
   elasticity = 0.25;
   friction = 0.25;
   armingDelay = 0;
   drag = 0.0;

   lifetime = 1000;
};


datablock ParticleData(satchelChargeBlinkParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 0.0;   
   inheritedVelFactor   = 0.0;

   lifetimeMS           = 100;  
   lifetimeVarianceMS   = 0;  

   textureName          = "~/data/textures/effects/particle/flare";

   useInvAlpha = false;
   spinRandomMin = -0.0;
   spinRandomMax = 0.0;

   colors[0]     = "1 0.2 0.2 1";
   colors[1]     = "1 0.2 0.2 1";
   colors[2]     = "1 1 1 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 1.0;
   sizes[2]      = 1.0;

   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleData(satchelChargeBlinkLargeParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 0.0;   
   inheritedVelFactor   = 0.0;

   lifetimeMS           = 100;  
   lifetimeVarianceMS   = 0;  

   textureName          = "~/data/textures/effects/particle/flare";

   useInvAlpha = false;
   spinRandomMin = -0.0;
   spinRandomMax = 0.0;

   colors[0]     = "1 0.2 0.2 1";
   colors[1]     = "1 0.2 0.2 1";
   colors[2]     = "1 1 1 0.0";

   sizes[0]      = 3.0;
   sizes[1]      = 3.0;
   sizes[2]      = 3.0;

   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};


datablock ParticleEmitterData(satchelChargeBlinkSlowEmitter)
{
   ejectionPeriodMS = 500;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;  

   particles = "satchelChargeBlinkParticle";
};

datablock ParticleEmitterData(satchelChargeBlinkMidEmitter)
{
   ejectionPeriodMS = 250;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;  

   particles = "satchelChargeBlinkParticle";
};

datablock ParticleEmitterData(satchelChargeBlinkFastEmitter)
{
   ejectionPeriodMS = 50;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;  

   particles = "satchelChargeBlinkLargeParticle";
};

datablock ShapeBaseImageData(satchelChargeImage)
{
   shapeFile = "~/data/shapes/weapons/disc_shell.dts";

   offset = "0 0 0.5";

   rotation = "1 0 0 90";

   stateName[0] = "BlinkSlow";
   stateEmitter[0] = satchelChargeBlinkSlowEmitter;
   stateEmitterTime[0] = 7;
   stateTimeoutValue[0] = 7;
   stateTransitionOnTimeout[0] = "BlinkMid";

   stateName[1] = "BlinkMid";
   stateEmitter[1] = satchelChargeBlinkMidEmitter;
   stateEmitterTime[1] = 2;
   stateTimeoutValue[1] = 2;
   stateTransitionOnTimeout[1] = "BlinkFast";

   stateName[2] = "BlinkFast";
   stateEmitter[2] = satchelChargeBlinkFastEmitter;
   stateEmitterTime[2] = 2;
   stateTimeoutValue[2] = 2;
   stateTransitionOnTimeout[2] = "BlinkFast";
};


datablock ItemData(satchelCharge)
{
   className = "Grenade";
   category = "Grenade";

   dynamicType      = $TypeMasks::DamagableItemObjectType;
   
   shapeFile = "~/data/shapes/weapons/chaingun_ammo.dts";
   mass = 75;
   elasticity = 0.2;
   friction = 0.6;
   
   throwForce = 1000;
   
   inventoryName = "Satchel Charge";
   maxInventory = 100;
   iconName = "Grenade";
   
   regenDelay = 3000;
   energyUsage = 0;

   computeCRC = true;

   grenadeTime = 10000 ;
   grenadeProjectile = handGrenadeProjectile;
   grenadeImage = satchelChargeImage;
};
