
datablock ParticleData(ShotgunFlashParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -2;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 30;
	textureName          = "~/data/textures/effects/particle/flame01";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0 0.9";
	colors[1]     = "1 0.0 0.0 0.0";
	sizes[0]      = 1.5;
	sizes[1]      = 0.2;
};
datablock ParticleEmitterData(ShotgunFlashEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   ejectionOffsetVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShotgunFlashParticle";
};


datablock ParticleData(ShotgunLeadParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 250;
	lifetimeVarianceMS   = 120;
	textureName          = "~/data/textures/effects/particle/dirt01";
	spinSpeed		= 50.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.5";
	colors[1]     = "0.5 0.5 0.5 0.5";
   colors[2]     = "0.5 0.5 0.5 0";

	sizes[0]      = 1.25;
	sizes[1]      = 3.0;
   sizes[2]      = 3.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(ShotgunLeadEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 150;
   velocityVariance = 50.0;
   ejectionOffset   = 0.0;
   ejectionOffsetVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShotgunLeadParticle";
};



// -----------------------------------------------------------------------------
// -- Logical, Projectile and Weapon
// -----------------------------------------------------------------------------

datablock DebrisData( ShotgunShell )
{
    shapeFile             = "~/data/shapes/weapons/disc_shell.dts";

    lifetime              = 5.0;
    minSpinSpeed          = 300.0;
    maxSpinSpeed          = 400.0;

    elasticity            = 0.7;
    friction              = 0.2;
    numBounces            = 3;

    staticOnMaxBounce     = true;
    snapOnMaxBounce       = false;
    fade                  = true;
};

// -----------------------------------------------------------------------------
// -- Ammunition
// -----------------------------------------------------------------------------

datablock ItemData( ShotgunAmmo )
{
    category         = "Ammo";
    className        = "Ammo";

    shapeFile        = "~/data/shapes/weapons/disc_shell.dts";
    mass             = 80;
    elasticity       = 0.2;
    friction         = 0.6;

    throwForce       = 1000;

    //pickUpName       = "disc launcher ammo";
    inventoryName    = "Shotgun Ammo";
    maxInventory     = 5;
    weapon           = Shotgun;
    regendelay       = 3000;
    energyUsage      = 15;
};

// -----------------------------------------------------------------------------

datablock ItemData( Shotgun )
{
    category             = "Weapon";
    className            = "Weapon";
    
    // -- dont pay any attention to this variable UNLESS this is a mod weapon
    //    this value associates a weapon icon and reticle with this weapon.
    //    note that the BASE client only contains associations for base weapons.
    //    this means that server side mods should only use profiles for base weapons.
    clientProfile        = "Shotgun";
    
    shapeFile            = "~/data/shapes/weapons/disc_wep.dts";
    mass                 = 100;
    elasticity           = 0.2;
    friction             = 0.6;
    emap                 = true;

    inventory            = true;
    inventoryName        = "Shotgun";
    hudName              = "Shotgun";
    inventoryRequirement = "";
    inventoryDescription = "";
    iconName = "Disc";

    
    computeCRC           = $pref::Server::checkCRC;

    throwForce           = 1500;

    //pickUpName           = "a disc launcher";
    image                = ShotgunImage;
    ammo                 = ShotgunAmmo;
};

// -----------------------------------------------------------------------------

datablock ShapeBaseImageData( ShotgunImage )
{
    className                        = "WeaponImage";
    shapeFile                        = "~/data/shapes/weapons/disc_wep.dts";
    mountPoint                       = $WeaponSlot;

    //                                 +R/-L | +F/-B | +U/-D
    //offset                           = "0.15 -0.40 0.00";
    eyeOffset                        = "0.25 0.43 -0.34";
    rotation                         = "1 0 0 0";
    eyeRotation                      = "1 0 0 0";
    //scale = "0.5 0.5 0.5";

    usesEnergy                       = false;
    minEnergy                        = 0;

    lightType                        = "NoLight";
    lightColor                       = "1.000000 1.000000 1.000000 1.000000";
    lightTime                        = "1000";
    lightRadius                      = "10";

    shellExitDir                     = "0.707107 0 0.707107";
    shellExitVariance                = "20";
    shellVelocity                    = "5";

    cloakable                        = true;
    correctMuzzleVector              = true;
    emap                             = true;
    firstPerson                      = true;

    projectileType                   = LinearProjectile;  
    item                             = Shotgun;
    casing                           = ShotgunShell;
    ammo                             = ShotgunAmmo;
    projectile                       = "";
    projectileSpread                 = 0/1000;
    
    // ----

    stateName[0]                     = "PreActivate";
    stateTransitionOnLoaded[0]       = "CheckAmmo";

    stateName[1]                     = "Activate";
    stateTransitionOnTimeout[1]      = "Ready";
    stateTimeoutValue[1]             = 0.725;
    stateSequence[1]                 = "ready";
    stateSound[1]                    = "ShotgunMountSound";

    stateName[2]                     = "Ready";
    stateTransitionOnNoAmmo[2]       = "Noammo";
    stateTransitionOnTriggerDown[2]  = "Fire";
    stateSequence[2]                 = "ready";
    stateSound[2]                    = "ShotgunIdleSound";

    stateName[3]                     = "Fire";
    stateTransitionOnTimeout[3]      = "Fire2";
    stateTimeoutValue[3]             = 0.01;
    stateFire[3]                     = true;
    stateRecoil[3]                   = LightRecoil;
    stateAllowImageChange[3]         = false;
    stateSequence[3]                 = "Fire";
    stateScript[3]                   = "onFire";
    stateEjectShell[3]               = true;
    stateSound[3]                    = "ShotgunFireSound";
    stateEmitter[3] = ShotgunFlashEmitter;
    stateEmitterNode[3] = "muzzleNode";
    stateEmitterTime[3] = 0.1;

    stateName[9] = "Fire2";
    stateTimeoutValue[9] = 0.01;
    stateTransitionOnTimeout[9] = "Reload";
    stateEmitter[9] = ShotgunLeadEmitter;
    stateEmitterNode[9] = "muzzleNode";
    stateEmitterTime[9] = 0.05;
    


    stateName[4]                     = "Reload";
    stateTransitionOnAmmo[4]         = "doReload";
    stateTransitionOnNoAmmo[4]       = "NoAmmo";
    stateAllowImageChange[4]         = false;

    stateName[5]                     = "Noammo";
    stateTransitionOnAmmo[5]         = "doReload";
    stateSequence[5]                 = "Noammo";
    stateTransitionOnTriggerDown[5]  = "DryFire";

    stateName[6]                     = "Dryfire";
    stateSound[6]                    = "ShotgunDryfireSound";
    stateTimeoutValue[6]             = 1.0;
    stateSequence[6]                 = "Noammo";
    stateTransitionOnTimeout[6]      = "Noammo";

    stateName[7]                     = "CheckAmmo";
    stateTransitionOnAmmo[7]         = "Ready"; //"Activate";
    stateTransitionOnNoAmmo[7]       = "NoAmmo";
  

    stateName[8]                     = "doReload";
    stateTransitionOnTimeout[8]      = "Ready";
    stateTimeoutValue[8]             = 0.725;
    stateSequence[8]                 = "Reload";
    stateSound[8]                    = "ShotgunReloadSound";
    stateAllowImageChange[8]         = false;
};

// -----------------------------------------------------------------------------
// -- Functions
// -----------------------------------------------------------------------------

function ShotgunImage::onFire(%data, %player, %slot)
{
   if(%player.invincible)
      %player.schedule(150, setInvincible, false);

   //if(isObject(%data.ammo))
   //   %player.decInventory( %data.ammo, 1 );

    
   //volume search around the player
   //pick out people that are in front of the player
   //damage accordingly
}  


// -----------------------------------------------------------------------------
