struct ConnectData
{
   float4 hpos      : POSITION;
   float2 detCoord  : TEXCOORD0;
   float3  fade     : TEXCOORD1;
};

struct Fragout
{
   float4 col : COLOR0;
};

Fragout main( ConnectData IN,
              uniform sampler2D detMap          : register(S0)
              )
{
   Fragout OUT;
   
   float4 diff = tex2D(detMap, IN.detCoord);
   
   OUT.col = lerp(float4(0.5, 0.5, 0.5, 1), diff * 0.6 + 0.2, IN.fade.x);
   return OUT;
}
