#define IN_HLSL
#include "../shdrConsts.h"
#include "atlas.h"

//-----------------------------------------------------------------------------
// Main
//-----------------------------------------------------------------------------
VertDetailConnectData main( VertData IN,
                  uniform float4x4 modelView : register(C0),
                  uniform float3   eyePos    : register(VC_EYE_POS),
                  uniform float    morphT    : register(C49),
                  uniform float3   detData   : register(C50)
                  )
{
   VertDetailConnectData OUT;

   // Apply morph calculations.
   float4 realPos = IN.position + (IN.morphCoord * morphT);
   realPos.w = 1;

   // Transform and return.
   OUT.hpos = mul(modelView, realPos);
 
   // Do the detail map calculations.
   float eyeDist = distance( IN.position, eyePos );
   OUT.detCoord = IN.texCoord * detData.z;                 // Amplify texcoords.
   OUT.fade.x     = 1.0 - (eyeDist - detData.x) * detData.y; // And fade with distance.
   OUT.fade.yz    = 0.f;
   
   return OUT;
}
